import { Location, Action, History } from 'history';
import { AnyAction as ReduxAction } from 'redux';
export declare const CALL_HISTORY_METHOD = "@@router/CALL_HISTORY_METHOD";
export declare const LOCATION_CHANGE = "@@router/LOCATION_CHANGE";
export declare type HistoryMethods = 'push' | 'replace' | 'go' | 'goBack' | 'goForward';
export declare const locationChangeAction: <T>(location: Location<T>, action: Action) => {
    type: string;
    payload: {
        location: Location<T>;
        action: Action;
    };
};
export declare const push: (...args: Parameters<History[HistoryMethods]>) => ReduxAction;
export declare const replace: (...args: Parameters<History[HistoryMethods]>) => ReduxAction;
export declare const go: (...args: Parameters<History[HistoryMethods]>) => ReduxAction;
export declare const goBack: (...args: Parameters<History[HistoryMethods]>) => ReduxAction;
export declare const goForward: (...args: Parameters<History[HistoryMethods]>) => ReduxAction;
