"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createRouterMiddleware = void 0;
var actions_1 = require("./actions");
var createRouterMiddleware = function (_a) {
    var history = _a.history, showHistoryAction = _a.showHistoryAction;
    return function () {
        return function (next) {
            return function (action) {
                if (action.type !== actions_1.CALL_HISTORY_METHOD) {
                    return next(action);
                }
                var method = action.payload.method;
                var args = action.payload.args;
                // eslint-disable-next-line default-case
                switch (method) {
                    case 'push':
                        history.push.apply(history, args);
                        break;
                    case 'replace':
                        history.replace.apply(history, args);
                        break;
                    case 'go':
                        history.go.apply(history, args);
                        break;
                    case 'goBack':
                        history.goBack && history.goBack.apply(history, args);
                        //@ts-ignore //support history 5.x
                        history.back && history.back.apply(history, args);
                        break;
                    case 'goForward':
                        history.goForward && history.goForward.apply(history, args);
                        //@ts-ignore //support history 5.x
                        history.forward && history.forward.apply(history, args);
                        break;
                }
                if (showHistoryAction)
                    return next(action);
            };
        };
    };
};
exports.createRouterMiddleware = createRouterMiddleware;
//# sourceMappingURL=middleware.js.map